package com.franckbarbier.enterprise_architect;

public class Enterprise_Architect_Java_API {

    public static void main(String[] args) {
        // 'ea' directory as repository...
        // See POM for 'ea' repository setup
        // -right click- (project) >> Run Maven >> Goals...
        // deploy:deploy-file -DgroupId=org.sparx -DartifactId=ea -Dversion=1.0 -Durl=file:./ea/ -DrepositoryId=ea -DupdateReleaseInfo=true -Dfile=./lib/eaapi.jar
        System.out.println("Java working directory: " + System.getProperty("user.dir"));

        org.sparx.Repository model = new org.sparx.Repository();
        System.out.println("'model.GetIsSecurityEnabled()': " + model.GetIsSecurityEnabled()); // 'false'
        model.OpenFile("C:\\Users\\franc\\Desktop\\BCMS.qea");

        // Get the repository from execution *WITHIN* Enterprise Architect:
        // model = org.sparx.Services.GetRepository(processID); // 'processID' of Enterprise Architect execution instance is passed automatically...
        org.sparx.Collection<org.sparx.Package> packages = model.GetModels();
        for (short i = 0; i < packages.GetCount(); i++) {
            org.sparx.Package p = packages.GetAt(i);
            // model.WriteOutput("Script", p.GetName(), 0); // Write 'Script' tab of 'System Output' window...
            System.out.println(p.GetName() + " is a model as root package...");
        }
        // Database may be locked when security is enabled, so SQL 'UPDATE' may fail:
        model.Execute("UPDATE t_object SET Status = 'Approved' WHERE Object_Type = 'Package';");
        model.Execute("UPDATE t_object SET GenType = NULL;"); 
        model.Execute("COMMIT;");
        model.CloseFile();
        model.Exit();
    }
}
